/*
 * Purpose: Local output buffer to device export routine for vmix (int)
 */
/*
 * This file is part of Open Sound System
 *
 * Copyright (C) 4Front Technologies 1996-2007.
 *
 * This software is released under CDDL 1.0 source license for operating systems
 * that have their full source code available under the BSD or CDDL licenses.
 *
 * See the COPYING file included in the main directory of this source
 * distribution. Please contact sales@opensound.com for further info.
 */

/*
 * NOTE! This is not the development version of this file. Please download the
 * sources of the latest Open Sound System version from 
 * http://developer.opensound.com/sources if you plan to make any changes
 * to the software. We may not be able to incorporate changes made to this
 * file back to the official OSS version.
 */

int i, ch;
int vol;

#define RANGE_MAX	((1<<24)-1)
#define RANGE_MIN	-(1<<24)

vol = vmix_db_table[eng->outvol / 5];

for (ch = 0; ch < channels; ch++)
  {
    op = (SAMPLE_TYPE *) outbuf;
    op += ch;

    int vu;
    int *chbuf;

    chbuf = chbufs[ch];

    vu = eng->vu[ch % 2];
    vu = vu * 65536;

    for (i = 0; i < samples; i++)
      {
	int tmp;

	tmp = *chbuf++;

	tmp = (tmp * vol) / VMIX_VOL_SCALE;
	tmp /= 3; /* TODO: Temporary clipping protection (to be removed) */

/*
 * Check for clipping. Decrease volume if necessary.
 */
	if (tmp<RANGE_MIN)
           {
	   	tmp=RANGE_MIN;
	        eng->outvol -= 1;
		vol /= 2;
	   }
	else
	   if (tmp>RANGE_MAX)
	      {
	   	tmp=RANGE_MAX;
	        eng->outvol -= 1;
		vol /= 2;
	      }
	
	*op = VMIX_BYTESWAP(INT_EXPORT(tmp));
	op += channels;

	/* VU meter */
	if (tmp < 0)
	  tmp = -tmp;
	if (tmp > vu)
	  vu = tmp;
      }

    if (ch < 2)
      {
	vu = vu / 65536;
	eng->vu[ch] = vu;
      }
  }
